searchNodes=[{"type":"module","title":"GSS","doc":"Bootstrap Google Spreadsheet application.","ref":"GSS.html"},{"type":"function","title":"GSS.config/2","doc":"Read config settings scoped for GSS.","ref":"GSS.html#config/2"},{"type":"function","title":"GSS.start/2","doc":"Callback implementation for Application.start/2 .","ref":"GSS.html#start/2"},{"type":"module","title":"GSS.Client","doc":"Model of Client abstraction This process is a Producer for this GenStage pipeline.","ref":"GSS.Client.html"},{"type":"function","title":"GSS.Client.config/2","doc":"Read config settings scoped for GSS client.","ref":"GSS.Client.html#config/2"},{"type":"function","title":"GSS.Client.dispatcher_hash/1","doc":"Divide request into to partitions :read and :write","ref":"GSS.Client.html#dispatcher_hash/1"},{"type":"function","title":"GSS.Client.handle_call/3","doc":"Adds an event to the queue","ref":"GSS.Client.html#handle_call/3"},{"type":"function","title":"GSS.Client.handle_demand/2","doc":"Gives events for the next stage to process when requested","ref":"GSS.Client.html#handle_demand/2"},{"type":"function","title":"GSS.Client.init/1","doc":"Callback implementation for GenStage.init/1 .","ref":"GSS.Client.html#init/1"},{"type":"function","title":"GSS.Client.request/5","doc":"Issues an HTTP request with the given method to the given url. This function is usually used indirectly by get/3 , post/4 , put/4 , etc Args: method - HTTP method as an atom ( :get , :head , :post , :put , :delete , etc.) url - target url as a binary string or char list body - request body. See more below headers - HTTP headers as an orddict (e.g., [{&quot;Accept&quot;, &quot;application/json&quot;}] ) options - Keyword list of options Body: binary, char list or an iolist {:form, [{K, V}, ...]} - send a form url encoded {:file, ~s(/path/to/file)} - send a file {:stream, enumerable} - lazily send a stream of binaries/charlists Options: :result_timeout - receive result timeout, in milliseconds. Default is 2 minutes :timeout - timeout to establish a connection, in milliseconds. Default is 8000 :recv_timeout - timeout used when receiving a connection. Default is 5000 :proxy - a proxy to be used for the request; it can be a regular url or a {Host, Port} tuple :proxy_auth - proxy authentication {User, Password} tuple :ssl - SSL options supported by the ssl erlang module :follow_redirect - a boolean that causes redirects to be followed :max_redirect - an integer denoting the maximum number of redirects to follow :params - an enumerable consisting of two-item tuples that will be appended to the url as query string parameters Timeouts can be an integer or :infinity This function returns {:ok, response} or {:ok, async_response} if the request is successful, {:error, reason} otherwise. Examples request(:post, ~s( https://my.website.com), ~s({\\&quot;foo\\&quot;: 3}), [{&quot;Accept&quot;, &quot;application/json&quot;}])","ref":"GSS.Client.html#request/5"},{"type":"function","title":"GSS.Client.request_async/5","doc":"Starts a task with request that must be awaited on.","ref":"GSS.Client.html#request_async/5"},{"type":"function","title":"GSS.Client.start_link/1","doc":"","ref":"GSS.Client.html#start_link/1"},{"type":"type","title":"GSS.Client.event/0","doc":"","ref":"GSS.Client.html#t:event/0"},{"type":"type","title":"GSS.Client.partition/0","doc":"","ref":"GSS.Client.html#t:partition/0"},{"type":"module","title":"GSS.Client.Limiter","doc":"Model of Limiter request subscribed to Client with partition :write or :read This process is a ProducerConsumer for this GenStage pipeline.","ref":"GSS.Client.Limiter.html"},{"type":"function","title":"GSS.Client.Limiter.ask_and_schedule/1","doc":"Check to reach limit. If limit not reached ask again after :interval timeout, otherwise ask after :max_interval timeout.","ref":"GSS.Client.Limiter.html#ask_and_schedule/1"},{"type":"function","title":"GSS.Client.Limiter.handle_demand/2","doc":"Gives events for the next stage to process when requested","ref":"GSS.Client.Limiter.html#handle_demand/2"},{"type":"function","title":"GSS.Client.Limiter.handle_events/3","doc":"Callback implementation for GenStage.handle_events/3 .","ref":"GSS.Client.Limiter.html#handle_events/3"},{"type":"function","title":"GSS.Client.Limiter.handle_info/2","doc":"Ask new events if needed","ref":"GSS.Client.Limiter.html#handle_info/2"},{"type":"function","title":"GSS.Client.Limiter.handle_subscribe/4","doc":"Callback implementation for GenStage.handle_subscribe/4 .","ref":"GSS.Client.Limiter.html#handle_subscribe/4"},{"type":"function","title":"GSS.Client.Limiter.init/1","doc":"Callback implementation for GenStage.init/1 .","ref":"GSS.Client.Limiter.html#init/1"},{"type":"function","title":"GSS.Client.Limiter.start_link/1","doc":"Starts an limiter manager linked to the current process. If the event manager is successfully created and initialized, the function returns {:ok, pid}, where pid is the PID of the server. If a process with the specified server name already exists, the function returns {:error, {:already_started, pid}} with the PID of that process. Options :name - used for name registration as described in the &quot;Name registration&quot; section of the module documentation :interval - ask new events from producer after :interval milliseconds. :max_demand - count of maximum requests per :maximum_interval :max_interval - maximum time that allowed in :max_demand requests :clients - list of clients with partition options. For example [{GSS.Client, partition: :read}}] .","ref":"GSS.Client.Limiter.html#start_link/1"},{"type":"type","title":"GSS.Client.Limiter.options/0","doc":"","ref":"GSS.Client.Limiter.html#t:options/0"},{"type":"type","title":"GSS.Client.Limiter.state/0","doc":"","ref":"GSS.Client.Limiter.html#t:state/0"},{"type":"module","title":"GSS.Client.Request","doc":"Worker of Request subscribed to Limiter, call request to API and send an answer to Client.","ref":"GSS.Client.Request.html"},{"type":"function","title":"GSS.Client.Request.handle_events/3","doc":"Callback implementation for GenStage.handle_events/3 .","ref":"GSS.Client.Request.html#handle_events/3"},{"type":"function","title":"GSS.Client.Request.handle_subscribe/4","doc":"Set the subscription to manual to control when to ask for events","ref":"GSS.Client.Request.html#handle_subscribe/4"},{"type":"function","title":"GSS.Client.Request.init/1","doc":"Callback implementation for GenStage.init/1 .","ref":"GSS.Client.Request.html#init/1"},{"type":"function","title":"GSS.Client.Request.start_link/1","doc":"Starts an request worker linked to the current process. Takes events from Limiter and send requests through HTTPoison Options :name - used for name registration as described in the &quot;Name registration&quot; section of the module documentation. Default is Elixir.GSS.Client.Request :limiters - list of limiters with max_demand options. For example [{Elixir.GSS.Client.Limiter, max_demand: 1}] .","ref":"GSS.Client.Request.html#start_link/1"},{"type":"type","title":"GSS.Client.Request.options/0","doc":"","ref":"GSS.Client.Request.html#t:options/0"},{"type":"type","title":"GSS.Client.Request.state/0","doc":"","ref":"GSS.Client.Request.html#t:state/0"},{"type":"module","title":"GSS.Client.RequestParams","doc":"","ref":"GSS.Client.RequestParams.html"},{"type":"type","title":"GSS.Client.RequestParams.t/0","doc":"","ref":"GSS.Client.RequestParams.html#t:t/0"},{"type":"module","title":"GSS.Client.Supervisor","doc":"Supervisor to keep track of initialized Client, Limiter and Request processes.","ref":"GSS.Client.Supervisor.html"},{"type":"function","title":"GSS.Client.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"GSS.Client.Supervisor.html#child_spec/1"},{"type":"function","title":"GSS.Client.Supervisor.init/1","doc":"Callback implementation for Supervisor.init/1 .","ref":"GSS.Client.Supervisor.html#init/1"},{"type":"function","title":"GSS.Client.Supervisor.start_link/1","doc":"","ref":"GSS.Client.Supervisor.html#start_link/1"},{"type":"module","title":"GSS.Registry","doc":"Google spreadsheets core authorization. Automatically updates access token after expiration.","ref":"GSS.Registry.html"},{"type":"function","title":"GSS.Registry.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"GSS.Registry.html#child_spec/1"},{"type":"function","title":"GSS.Registry.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"GSS.Registry.html#init/1"},{"type":"function","title":"GSS.Registry.new_spreadsheet/3","doc":"Add or replace Google Spreadsheet in a registry.","ref":"GSS.Registry.html#new_spreadsheet/3"},{"type":"function","title":"GSS.Registry.spreadsheet_pid/2","doc":"Fetch Google Spreadsheet proccess by it's id in the registry.","ref":"GSS.Registry.html#spreadsheet_pid/2"},{"type":"function","title":"GSS.Registry.start_link/1","doc":"","ref":"GSS.Registry.html#start_link/1"},{"type":"function","title":"GSS.Registry.token/0","doc":"Get account authorization token.","ref":"GSS.Registry.html#token/0"},{"type":"type","title":"GSS.Registry.state/0","doc":"State of Google Cloud API : %{ auth : % Goth.Token { expires : 1453356568 , token : &quot;ya29.cALlJ4HHWRvMkYB-WsAR-CZnexE459yA7QPqKg3nei1y2T7-iqmbcgxb8XrTATNn_Blim&quot; , type : &quot;Bearer&quot; } }","ref":"GSS.Registry.html#t:state/0"},{"type":"module","title":"GSS.Spreadsheet","doc":"Model of Google Spreadsheet for external interaction.","ref":"GSS.Spreadsheet.html"},{"type":"function","title":"GSS.Spreadsheet.append_row/4","doc":"Append row in a spreadsheet after an index.","ref":"GSS.Spreadsheet.html#append_row/4"},{"type":"function","title":"GSS.Spreadsheet.append_rows/4","doc":"Batch update to append multiple rows.","ref":"GSS.Spreadsheet.html#append_rows/4"},{"type":"function","title":"GSS.Spreadsheet.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"GSS.Spreadsheet.html#child_spec/1"},{"type":"function","title":"GSS.Spreadsheet.clear_row/3","doc":"Clear row in a spreadsheet by index.","ref":"GSS.Spreadsheet.html#clear_row/3"},{"type":"function","title":"GSS.Spreadsheet.clear_rows/2","doc":"Batched clear, which deletes more then one record. Pass either an array of ranges, or start and end row indexes.","ref":"GSS.Spreadsheet.html#clear_rows/2"},{"type":"function","title":"GSS.Spreadsheet.clear_rows/3","doc":"","ref":"GSS.Spreadsheet.html#clear_rows/3"},{"type":"function","title":"GSS.Spreadsheet.clear_rows/4","doc":"","ref":"GSS.Spreadsheet.html#clear_rows/4"},{"type":"function","title":"GSS.Spreadsheet.col_number_to_letters/1","doc":"","ref":"GSS.Spreadsheet.html#col_number_to_letters/1"},{"type":"function","title":"GSS.Spreadsheet.fetch/2","doc":"Granural read by a custom range from a spreadsheet.","ref":"GSS.Spreadsheet.html#fetch/2"},{"type":"function","title":"GSS.Spreadsheet.id/1","doc":"Get spreadsheet internal id.","ref":"GSS.Spreadsheet.html#id/1"},{"type":"function","title":"GSS.Spreadsheet.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"GSS.Spreadsheet.html#init/1"},{"type":"function","title":"GSS.Spreadsheet.properties/1","doc":"Get spreadsheet properties.","ref":"GSS.Spreadsheet.html#properties/1"},{"type":"function","title":"GSS.Spreadsheet.range/4","doc":"","ref":"GSS.Spreadsheet.html#range/4"},{"type":"function","title":"GSS.Spreadsheet.range/5","doc":"","ref":"GSS.Spreadsheet.html#range/5"},{"type":"function","title":"GSS.Spreadsheet.read_row/3","doc":"Read row in a spreadsheet by index.","ref":"GSS.Spreadsheet.html#read_row/3"},{"type":"function","title":"GSS.Spreadsheet.read_rows/2","doc":"Batched read, which returns more than one record. Pass either an array of ranges (or rows), or start and end row indexes. By default it returns nils for an empty rows, use pad_empty: true and column_to: integer options to fill records with an empty string values.","ref":"GSS.Spreadsheet.html#read_rows/2"},{"type":"function","title":"GSS.Spreadsheet.read_rows/3","doc":"","ref":"GSS.Spreadsheet.html#read_rows/3"},{"type":"function","title":"GSS.Spreadsheet.read_rows/4","doc":"","ref":"GSS.Spreadsheet.html#read_rows/4"},{"type":"function","title":"GSS.Spreadsheet.rows/2","doc":"Get total amount of rows in a spreadsheet.","ref":"GSS.Spreadsheet.html#rows/2"},{"type":"function","title":"GSS.Spreadsheet.sheets/2","doc":"Get spreadsheet sheets from properties.","ref":"GSS.Spreadsheet.html#sheets/2"},{"type":"function","title":"GSS.Spreadsheet.start_link/2","doc":"","ref":"GSS.Spreadsheet.html#start_link/2"},{"type":"function","title":"GSS.Spreadsheet.write_row/4","doc":"Override row in a spreadsheet by index.","ref":"GSS.Spreadsheet.html#write_row/4"},{"type":"function","title":"GSS.Spreadsheet.write_rows/4","doc":"Batch update to write multiple rows. Range schema should define the same amount of rows as amound of records in data and same amount of columns as entries in data record.","ref":"GSS.Spreadsheet.html#write_rows/4"},{"type":"type","title":"GSS.Spreadsheet.spreadsheet_data/0","doc":"","ref":"GSS.Spreadsheet.html#t:spreadsheet_data/0"},{"type":"type","title":"GSS.Spreadsheet.spreadsheet_response/0","doc":"","ref":"GSS.Spreadsheet.html#t:spreadsheet_response/0"},{"type":"type","title":"GSS.Spreadsheet.state/0","doc":"State of currently active Google spreadsheet: %{ spreadsheet_id =&gt; &quot;16Wgt0fuoYDgEAtGtYKF4jdjAhZez0q77UhkKdeKI6B4&quot; , list_name =&gt; nil }","ref":"GSS.Spreadsheet.html#t:state/0"},{"type":"module","title":"GSS.Spreadsheet.Supervisor","doc":"Supervisor to keep track of initialized spreadsheet processes.","ref":"GSS.Spreadsheet.Supervisor.html"},{"type":"function","title":"GSS.Spreadsheet.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"GSS.Spreadsheet.Supervisor.html#child_spec/1"},{"type":"function","title":"GSS.Spreadsheet.Supervisor.init/1","doc":"Callback implementation for DynamicSupervisor.init/1 .","ref":"GSS.Spreadsheet.Supervisor.html#init/1"},{"type":"function","title":"GSS.Spreadsheet.Supervisor.spreadsheet/2","doc":"","ref":"GSS.Spreadsheet.Supervisor.html#spreadsheet/2"},{"type":"function","title":"GSS.Spreadsheet.Supervisor.start_link/1","doc":"","ref":"GSS.Spreadsheet.Supervisor.html#start_link/1"},{"type":"exception","title":"GSS.GoogleApiError","doc":"Raised in case non 200 response code from Google Cloud API.","ref":"GSS.GoogleApiError.html"},{"type":"exception","title":"GSS.InvalidColumnIndex","doc":"Raised in case more than 255 columns is queried.","ref":"GSS.InvalidColumnIndex.html"},{"type":"exception","title":"GSS.InvalidInput","doc":"Raised in case invalid input params are passed","ref":"GSS.InvalidInput.html"},{"type":"exception","title":"GSS.InvalidRange","doc":"Raised in case invalid range is defined.","ref":"GSS.InvalidRange.html"},{"type":"extras","title":"Elixir Google Spreadsheets","doc":"Elixir library to read and write data of Google Spreadsheets. This library is based on Google Cloud API v4 and uses Google Service Accounts to manage it's content.","ref":"readme.html"},{"type":"extras","title":"Elixir Google Spreadsheets - Integration with Ecto","doc":"Check ecto_gss if you need to integrate your Google Spreadsheet with Ecto changesets for validation and other features. Setup Use this wizard to create or select a project in the Google Developers Console and automatically turn on the API. Click Continue , then Go to credentials . On the Add credentials to your project page , create Service account key . Select your project name as service account and JSON as key format, download the created key and rename it to service_account.json . Press Manage service accounts on a credential page, copy your Service Account Identifier : [projectname]@[domain].iam.gserviceaccount.com Create or open existing Google Spreadsheet document on your Google Drive and add Service Account Identifier as user invited in spreadsheet's Collaboration Settings . Add {:elixir_google_spreadsheets, &quot;~&gt; 0.3&quot;} to mix.exs under deps function, add :elixir_google_spreadsheets in your application list. Add service_account.json in your config.exs or other config file, like dev.exs or prod.secret.exs . config :elixir_google_spreadsheets, json : &quot;./config/service_account.json&quot; |&gt; File . read! Run mix deps.get &amp;&amp; mix deps.compile .","ref":"readme.html#integration-with-ecto"},{"type":"extras","title":"Elixir Google Spreadsheets - API limits","doc":"All Google API limits, suggested params are the following: config :elixir_google_spreadsheets , :client , request_workers : 50 , max_demand : 100 , max_interval : :timer . minutes ( 1 ) , interval : 100 , result_timeout : :timer . minutes ( 10 ) Since elixir 1.14 the following request params are used by default, you can modify them as :request_opts : [ timeout : :timer . seconds ( 8 ) , recv_timeout : :timer . seconds ( 5 ) , ssl : [ versions : [ :&quot;tlsv1.2&quot; ] , verify : :verify_peer , depth : 99 , cacerts : :certifi . cacerts ( ) , customize_hostname_check : [ match_fun : :public_key . pkix_verify_hostname_match_fun ( :https ) ] , reuse_sessions : false , crl_check : true , crl_cache : { :ssl_crl_cache , { :internal , [ http : 30000 ] } } ] ] Usage Initialise spreadsheet thread with it's id which you can fetch from URL: { :ok , pid } = GSS.Spreadsheet.Supervisor . spreadsheet ( &quot;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX-XXXXXXXXX&quot; ) Or if you wish to edit only a specific list: { :ok , pid } = GSS.Spreadsheet.Supervisor . spreadsheet ( &quot;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX-XXXXXXXXX&quot; , list_name : &quot;my_list3&quot; ) Sample operations: GSS.Spreadsheet.id(pid) GSS.Spreadsheet.properties(pid) GSS.Spreadsheet.sheets(pid) GSS.Spreadsheet.rows(pid) GSS.Spreadsheet.read_row(pid, 1, column_to: 5) GSS.Spreadsheet.read_rows(pid, 1, 10, column_to: 5, pad_empty: true) GSS.Spreadsheet.read_rows(pid, [1, 3, 5], column_to: 5, pad_empty: true) GSS.Spreadsheet.read_rows(pid, [&quot;A1:E1&quot;, &quot;A2:E2&quot;]) GSS.Spreadsheet.write_row(pid, 1, [&quot;1&quot;, &quot;2&quot;, &quot;3&quot;, &quot;4&quot;, &quot;5&quot;]) GSS.Spreadsheet.write_rows(pid, [&quot;A2:E2&quot;, &quot;A3:F3&quot;], [[&quot;1&quot;, &quot;2&quot;, &quot;3&quot;, &quot;4&quot;, &quot;5&quot;], [&quot;1&quot;, &quot;2&quot;, &quot;3&quot;, &quot;4&quot;, &quot;5&quot;, &quot;6&quot;]]) GSS.Spreadsheet.append_row(pid, 1, [&quot;1&quot;, &quot;2&quot;, &quot;3&quot;, &quot;4&quot;, &quot;5&quot;]) GSS.Spreadsheet.append_rows(pid, 1, [[&quot;1&quot;, &quot;2&quot;, &quot;3&quot;, &quot;4&quot;, &quot;5&quot;], [&quot;1&quot;, &quot;2&quot;, &quot;3&quot;, &quot;4&quot;, &quot;5&quot;, &quot;6&quot;]]) GSS.Spreadsheet.clear_row(pid, 1) GSS.Spreadsheet.clear_rows(pid, 1, 10) GSS.Spreadsheet.clear_rows(pid, [&quot;A1:E1&quot;, &quot;A2:E2&quot;]) Last function param of GSS.Spreadsheet function calls support the same Keyword options (in snake_case instead of camelCase), as defined in Google API Docs . We also define column_from and column_to Keyword options which control range of cell which will be queried. Default values: column_from = 1 - default is configurable as :default_column_from column_to = 26 - default is configurable as :default_column_to major_dimension = &quot;ROWS&quot; value_render_option = &quot;FORMATTED_VALUE&quot; datetime_render_option = &quot;FORMATTED_STRING&quot; value_render_option = &quot;USER_ENTERED&quot; insert_data_option = &quot;INSERT_ROWS&quot; Suggestions Recommended columns 26 (more on your own risk), max rows in a batch 100-300 depending on your data size per row, configurable as :max_rows_per_request ; Pull requests / reports / feedback are welcome.","ref":"readme.html#api-limits"}]